//===============================================================================
//  BD7411G.h
//
// Copyright (c) 2021 ROHM Co.,Ltd.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//===============================================================================

#ifndef BD7411G_H__
#define BD7411G_H__

#ifndef float32
#define float32            float
#endif  //float32

#define INIT_OK            (0)
#define INIT_NG            (-1)
#define DATA_ERROR         (0xFF)

#define ANALOG_NON_USE_PIN (100)
#define ANALOG_1_OUT_PIN   (A0)
#define ANALOG_2_OUT_PIN   (A2)

#define DRIVER_VERSION     (1.0F)

class BD7411G
{
    public:
        BD7411G(uint32_t connect_area);
        ~BD7411G();
        int32_t init(void);
        int32_t get_val(uint8_t *data);
        float32 get_version(void);

    private:
        uint32_t connect_pin;
        int8_t   init_flag;
};

#endif  //BD7411G_H__
